Imports System
Imports System.Text
Imports System.Runtime.InteropServices
Imports De.Tichnut.JewishCalendarZmanimDLL

Public Class Test

  Public Shared Sub Main
    GregorianHebrewDates()
    ShabbatDates()
    HolidayDates()
    HolidayNames()
    OmerCount()
    Readings()
    Times()
  End Sub

  Public Shared Sub GregorianHebrewDates
    Dim ErrorCode As Integer

    Console.WriteLine("Gregorian and Hebrew dates")

    Dim gDate, hDate As JEWCALDATE

    gDate.Day = 31
    gDate.Month = 6
    gDate.Year = 1981
    ErrorCode = JEWCALDLLAPI.JewcalGregorianDateToHebrewDate(gDate, hDate)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      Console.WriteLine("  1981-6-31 to Jewish date: Failed (returned success)")
    Else
      If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_INVALID_GREGORIAN_DAY Then
        Console.WriteLine("  1981-6-31 to Jewish date: OK")
      Else
        Console.WriteLine("  1981-6-31 to Jewish date: Failed (returned unexpected error code)")
      End If
    End If
    gDate.Day = 17
    gDate.Month = 6
    gDate.Year = 1981
    ErrorCode = JEWCALDLLAPI.JewcalGregorianDateToHebrewDate(gDate, hDate)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If hDate.Day = 15 And hDate.Month = 3 And hDate.Year = 5741 Then
        Console.WriteLine("  1981-06-17 to Jewish date: OK")
      Else
        Console.WriteLine("  1981-06-17 to Jewish date: Failed (returned incorrect result)")
      End If
    Else
      Console.WriteLine("  1981-06-17 to Jewish date: Failed (returned error code)")
    End If

    hDate.Day = 30
    hDate.Month = 2
    hDate.Year = 5730
    ErrorCode = JEWCALDLLAPI.JewcalHebrewDateToGregorianDate(hDate, gDate)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      Console.WriteLine("  30 Iyar 5730 to Gregorian date: Failed (returned success)")
    Else
      If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_INVALID_HEBREW_DAY Then
        Console.WriteLine("  30 Iyar 5730 to Gregorian date: OK")
      Else
        Console.WriteLine("  30 Iyar 5730 to Gregorian date: Failed (returned unexpected error code)")
      End If
    End If
    hDate.Day = 1
    hDate.Month = 3
    hDate.Year = 5753
    ErrorCode = JEWCALDLLAPI.JewcalHebrewDateToGregorianDate(hDate, gDate)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If gDate.Day = 21 And gDate.Month = 5 And gDate.Year = 1993 Then
        Console.WriteLine("  1 Sivan 5753 to Gregorian date: OK")
      Else
        Console.WriteLine("  1 Sivan 5753 to Gregorian date: Failed (returned incorrect result)")
      End If
    Else
      Console.WriteLine("  1 Sivan 5753 to Gregorian date: Failed (returned error code)")
    End If

    Dim ReturnMonthName As StringBuilder
    ReturnMonthName = New StringBuilder(256)
    ErrorCode = JEWCALDLLAPI.JewcalGetHebrewMonthName(3, 5766, _
            ReturnMonthName, 256, "English", "names.txt")
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If ReturnMonthName.ToString() = "Sivan" Then
        Console.WriteLine("  Hebrew month name of Sivan 5766: OK")
      Else
        Console.WriteLine("  Hebrew month name of Sivan 5766: Failed (returned incorrect month name)")
      End If
    Else
      Console.WriteLine("  Hebrew month name of Sivan 5766: Failed (returned error code)")
    End If
    ReturnMonthName = New StringBuilder(256)
    ErrorCode = JEWCALDLLAPI.JewcalGetHebrewMonthName(14, 5766, _
            ReturnMonthName, 256, "English", "names.txt")
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      Console.WriteLine("  Hebrew month name of 14th month of 5766: Failed (returned success)")
    Else
      Console.WriteLine("  Hebrew month name of 14th month of 5766: OK")
    End If
  End Sub

  Public Shared Sub ShabbatDates
    Dim ErrorCode As Integer

    Console.WriteLine("Shabbat dates")

    Dim gDate, gDate2 As JEWCALDATE
    gDate.Day = 17
    gDate.Month = 6
    gDate.Year = 1981
    ErrorCode = JEWCALDLLAPI.JewcalGetNearestShabbatGregorianDate(gDate, gDate2)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If gDate2.Day = 20 And gDate2.Month = 6 And gDate2.Year = 1981 Then
        Console.WriteLine("  Get nearest Shabbat to 1981-06-17: OK")
      Else
        Console.WriteLine("  Get nearest Shabbat to 1981-06-17: Failed (returned incorrect result)")
      End If
    Else
      Console.WriteLine("  Get nearest Shabbat to 1981-06-17: Failed (returned error code)")
    End If

    Dim hDate, hDate2 As JEWCALDATE
    hDate.Day = 1
    hDate.Month = 3
    hDate.Year = 5753
    ErrorCode = JEWCALDLLAPI.JewcalGetNearestShabbatHebrewDate(hDate, hDate2)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If hDate2.Day = 2 And hDate2.Month = 3 And hDate2.Year = 5753 Then
        Console.WriteLine("  Get nearest Shabbat to 1 Sivan 5753: OK")
      Else
        Console.WriteLine("  Get nearest Shabbat to 1 Sivan 5753: Failed (returned incorrect result)")
      End If
    Else
      Console.WriteLine("  Get nearest Shabbat to 1981-06-17: Failed (returned error code)")
    End If
  End Sub

  Public Shared Sub HolidayDates
    Dim ErrorCode As Integer

    Console.WriteLine("Holiday dates")

    Dim gDate, gDate2 As JEWCALDATE
    gDate.Day = 17
    gDate.Month = 6
    gDate.Year = 1981
    ErrorCode = JEWCALDLLAPI.JewcalGetNearestHolidayGregorianDate _
                       (True, True, "names.txt", gDate, gDate2, _
                        JEWCALDLLAPI.JEWCAL_DAY_HOLIDAY)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      ' Tu Beav is the next holiday, since fast days are not selected
      If gDate2.Day = 15 And gDate2.Month = 8 And gDate2.Year = 1981 Then
        Console.WriteLine("  Get nearest holiday to 1981-06-17: OK")
      Else
        Console.WriteLine("  Get nearest holiday to 1981-06-17: Failed (returned incorrect date)")
      End If
    Else
      Console.WriteLine("  Get nearest holiday to 1981-06-17: Failed (returned error code)")
    End If

    Dim hDate, hDate2 As JEWCALDATE
    hDate.Day = 1
    hDate.Month = 3
    hDate.Year = 5753
    ErrorCode = JEWCALDLLAPI.JewcalGetNearestHolidayHebrewDate _
                       (True, True, "names.txt", hDate, hDate2, _
                        JEWCALDLLAPI.JEWCAL_DAY_HOLIDAY)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      ' Next holiday is Shavuot I (Erev Shavuot is not counted as a holiday)
      If hDate2.Day = 6 And hDate2.Month = 3 And hDate2.Year = 5753 Then
        Console.WriteLine("  Get nearest holiday to 1 Sivan 5753: OK")
      Else
        Console.WriteLine("  Get nearest holiday to 1 Sivan 5753: Failed (returned incorrect date)")
      End If
    Else
      Console.WriteLine("  Get nearest holiday to 1 Sivan 5753: Failed (returned error code)")
    End If
  End Sub

  Public Shared Sub HolidayNames
    Dim ErrorCode As Integer

    Console.WriteLine("Holiday names")

    Dim ReturnHolidayName As StringBuilder
    ReturnHolidayName = New StringBuilder(256)
    Dim gDate As JEWCALDATE
    gDate.Day = 19
    gDate.Month = 7
    gDate.Year = 1981
    ErrorCode = JEWCALDLLAPI.JewcalGetJewishHolidayName(gDate, _
                       True, True, ReturnHolidayName, 256, _
                       "English", "names.txt")
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If ReturnHolidayName.ToString() = "Tzom Tammuz" Then
        Console.WriteLine("  Get Jewish holiday name on 1981-07-19: OK")
      Else
        Console.WriteLine("  Get Jewish holiday name on 1981-07-19: Failed (incorrect holiday name)")
      End If
    Else
      Console.WriteLine("  Get Jewish holiday name on 1981-07-19: Failed (returned error code)")
    End If

    Dim HolidayInfo As JEWCALGETHOLIDAYINFO
    HolidayInfo.cbSize = Marshal.SizeOf(HolidayInfo)
    gDate.Day = 3
    gDate.Month = 6
    gDate.Year = 2006
    HolidayInfo.GregorianDate = Marshal.AllocCoTaskMem(Marshal.SizeOf(gDate))
    Marshal.StructureToPtr(gDate, HolidayInfo.GregorianDate, False)
    HolidayInfo.IsDiaspora = True
    HolidayInfo.PostponeShushanPurim = True
    HolidayInfo.cbMax = 256
    HolidayInfo.ReturnString = New String(" ", HolidayInfo.cbMax)
    HolidayInfo.Language = "English"
    HolidayInfo.NameFile = "names.txt"
    ErrorCode = JEWCALDLLAPI.JewcalGetJewishHolidayNameEx(HolidayInfo)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If HolidayInfo.ReturnString = "Shavuot II" And HolidayInfo.DayOfHoliday = 2 And HolidayInfo.WeekdayOfHoliday = JEWCALDLLAPI.JEWCAL_WEEKDAY_SATURDAY Then
        Console.WriteLine("  Get Jewish holiday info on 2006-06-03: OK")
      Else
        Console.WriteLine("  Get Jewish holiday info on 2006-06-03: Failed (incorrect data)")
      End If
    Else
      Console.WriteLine("  Get Jewish holiday info on 2006-06-03: Failed (returned error code)")
    End If
  End Sub

  Public Shared Sub OmerCount
    Dim ErrorCode As Integer

    Console.WriteLine("Omer counting")

    Dim hDate As JEWCALDATE
    Dim OmerCount As Integer

    hDate.Day = 12
    hDate.Month = 2
    hDate.Year = 5766
    ErrorCode = JEWCALDLLAPI.JewcalGetOmerCountHebrewDate(hDate, OmerCount)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If OmerCount = 27 Then
        Console.WriteLine("  Omer count for 12 Iyar 5766: OK")
      Else
        Console.WriteLine("  Omer count for 12 Iyar 5766: Failed (returned incorrect omer count)")
      End If
    Else
      Console.WriteLine("  Omer count for 12 Iyar 5766: Failed (returned error code)")
    End If

    hDate.Day = 13
    hDate.Month = 5
    hDate.Year = 5766
    ErrorCode = JEWCALDLLAPI.JewcalGetOmerCountHebrewDate(hDate, OmerCount)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_NO_OMER_COUNT Then
      Console.WriteLine("  Omer count for 13 Av 5766: OK")
    Else
      Console.WriteLine("  Omer count for 13 Av 5766: Failed (returned success)")
    End If
  End Sub

  Public Shared Sub Readings
    Dim ErrorCode As Integer

    Console.WriteLine("Readings")

    Dim ReadingInfo As JEWCALGETREADINGINFO
    ReadingInfo.cbSize = Marshal.SizeOf(ReadingInfo)
    Dim gDate As JEWCALDATE
    gDate.Day = 25
    gDate.Month = 2
    gDate.Year = 2006
    ReadingInfo.GregorianDate = Marshal.AllocCoTaskMem(Marshal.SizeOf(gDate))
    Marshal.StructureToPtr(gDate, ReadingInfo.GregorianDate, False)
    ReadingInfo.IsDiaspora = True
    ReadingInfo.cbParashaMax = 256
    ReadingInfo.Parasha = New String(" ", ReadingInfo.cbParashaMax)
    ReadingInfo.cbHaphtarahMax = 256
    ReadingInfo.Haphtarah = New String(" ", ReadingInfo.cbHaphtarahMax)
    ReadingInfo.Language = "English"
    ReadingInfo.NameFile = "names.txt"
    ErrorCode = JEWCALDLLAPI.JewcalGetReadingEx(ReadingInfo)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If ReadingInfo.Parasha.IndexOf("Mishpatim") <> -1 And _
         ReadingInfo.Parasha.IndexOf("Shekalim") <> -1 And _
         ReadingInfo.Haphtarah.IndexOf("II Kings") <> -1 Then
        Console.WriteLine("  Readings for 2006-02-25: OK")
      Else
        Console.WriteLine("  Readings for 2006-02-25: Failed (incorrect data)")
      End If
    Else
      Console.WriteLine("  Readings for 2006-02-25: Failed (returned error code)")
    End If
  End Sub

  Public Shared Sub Times
    Dim ErrorCode As Integer

    Console.WriteLine("Times")

    Dim dst1 As JEWCALDST
    Dim CalTime1 As JEWCALTIME
    CalTime1.cbSize = Marshal.SizeOf(CalTime1)
    CalTime1.Flags = JEWCALDLLAPI.JEWCALTIME_CITY Or _
                     JEWCALDLLAPI.JEWCALTIME_CALCFILE
    CalTime1.CityFile = "cities.txt"
    CalTime1.City = "Berlin"
    CalTime1.TimeFileName = "zmanim.txt"
    CalTime1.TimeInFile = "RabbeinuTam"
    CalTime1.DateToCalculate.Day = 13
    CalTime1.DateToCalculate.Month = 7
    CalTime1.DateToCalculate.Year = 2006
    dst1.StartWeekNo = JEWCALDLLAPI.DST_WEEK_LAST
    dst1.StartWeekday = JEWCALDLLAPI.DST_WEEKDAY_SUNDAY
    dst1.StartMonth = 3
    dst1.EndWeekNo = JEWCALDLLAPI.DST_WEEK_LAST
    dst1.EndWeekday = JEWCALDLLAPI.DST_WEEKDAY_SUNDAY
    dst1.EndMonth = 10
    CalTime1.DST = Marshal.AllocCoTaskMem(Marshal.SizeOf(dst1))
    Marshal.StructureToPtr(dst1, CalTime1.DST, False)
    ErrorCode = JEWCALDLLAPI.JewcalCalculateTime(CalTime1)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If CalTime1.ReturnHour = 22 And CalTime1.ReturnMin = 36 Then
        Console.WriteLine("  Sunset + 72 min, 2006-07-13, DST, Berlin (from file): OK")
      Else
        Console.WriteLine("  Sunset + 72 min, 2006-07-13, DST, Berlin (from file): Failed (incorrect result)")
      End If
    Else
      Console.WriteLine("  Sunset + 72 min, 2006-07-13, DST, Berlin (from file): Failed (returned error code)")
    End If

    Dim dst2 As JEWCALDST
    Dim CalTime2 As JEWCALTIME
    CalTime2.cbSize = Marshal.SizeOf(CalTime2)
    CalTime2.Flags = JEWCALDLLAPI.JEWCALTIME_COORDS Or _
                     JEWCALDLLAPI.JEWCALTIME_CALCDIRECT
    CalTime2.LatitudeType = JEWCALDLLAPI.LATITUDE_NORTH
    CalTime2.LatitudeDeg = 52
    CalTime2.LatitudeMin = 31
    CalTime2.LongitudeType = JEWCALDLLAPI.LONGITUDE_EAST
    CalTime2.LongitudeDeg = 13
    CalTime2.LongitudeMin = 23
    CalTime2.TimeZone = 1
    CalTime2.Calculation = "sunset + 72"
    CalTime2.DateToCalculate.Day = 13
    CalTime2.DateToCalculate.Month = 7
    CalTime2.DateToCalculate.Year = 2006
    dst2.StartWeekNo = JEWCALDLLAPI.DST_WEEK_LAST
    dst2.StartWeekday = JEWCALDLLAPI.DST_WEEKDAY_SUNDAY
    dst2.StartMonth = 3
    dst2.EndWeekNo = JEWCALDLLAPI.DST_WEEK_LAST
    dst2.EndWeekday = JEWCALDLLAPI.DST_WEEKDAY_SUNDAY
    dst2.EndMonth = 10
    CalTime2.DST = Marshal.AllocCoTaskMem(Marshal.SizeOf(dst2))
    Marshal.StructureToPtr(dst2, CalTime2.DST, False)
    ErrorCode = JEWCALDLLAPI.JewcalCalculateTime(CalTime2)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If CalTime2.ReturnHour = 22 And CalTime2.ReturnMin = 36 Then
        Console.WriteLine("  Sunset + 72 min, 2006-07-13, DST, Berlin (directly): OK")
      Else
        Console.WriteLine("  Sunset + 72 min, 2006-07-13, DST, Berlin (directly): Failed (incorrect result)")
      End If
    Else
      Console.WriteLine("  Sunset + 72 min, 2006-07-13, DST, Berlin (directly): Failed (returned error code)")
    End If

    Dim CalTime3 As JEWCALTIME
    CalTime3.cbSize = Marshal.SizeOf(CalTime3)
    CalTime3.Flags = JEWCALDLLAPI.JEWCALTIME_COORDS Or _
                     JEWCALDLLAPI.JEWCALTIME_CALCDIRECT
    CalTime3.LatitudeType = JEWCALDLLAPI.LATITUDE_NORTH
    CalTime3.LatitudeDeg = 52
    CalTime3.LatitudeMin = 31
    CalTime3.LongitudeType = JEWCALDLLAPI.LONGITUDE_EAST
    CalTime3.LongitudeDeg = 13
    CalTime3.LongitudeMin = 23
    CalTime3.TimeZone = 1
    CalTime3.Calculation = "sunset + 72"
    CalTime3.DateToCalculate.Day = 13
    CalTime3.DateToCalculate.Month = 7
    CalTime3.DateToCalculate.Year = 2006
    CalTime3.DST = IntPtr.Zero
    ErrorCode = JEWCALDLLAPI.JewcalCalculateTime(CalTime3)
    If ErrorCode = JEWCALDLLErrorCode.JEWCAL_ERROR_OK Then
      If CalTime3.ReturnHour = 21 And CalTime3.ReturnMin = 36 Then
        Console.WriteLine("  Sunset + 72 min, 2006-07-13, no DST, Berlin (directly): OK")
      Else
        Console.WriteLine("  Sunset + 72 min, 2006-07-13, no DST, Berlin (directly): Failed (incorrect result)")
      End If
    Else
      Console.WriteLine("  Sunset + 72 min, 2006-07-13, DST, Berlin (directly): Failed (returned error code)")
    End If
  End Sub

End Class
